// ClipboardNotificationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ClipboardNotification.h"
#include "ClipboardNotificationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedOk();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CClipboardNotificationDlg dialog



CClipboardNotificationDlg::CClipboardNotificationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClipboardNotificationDlg::IDD, pParent)
  , m_strLastUpdated("<Unknown>")
  , m_strClipboardText("")
  , m_bAlwaysOnTop(1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClipboardNotificationDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_STC_NOTTEXT, m_stcNotText);
  DDX_Text(pDX, IDC_EDT_LASTUPDATED, m_strLastUpdated);
  DDX_Text(pDX, IDC_EDT_CLIPBOARDTEXT, m_strClipboardText);
	DDX_Check(pDX, IDC_CHECK1, m_bAlwaysOnTop);
}

BEGIN_MESSAGE_MAP(CClipboardNotificationDlg, CDialog)
	//{{AFX_MSG_MAP(CClipboardNotificationDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DRAWCLIPBOARD, OnClipboardChange)
  ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
  ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// CClipboardNotificationDlg message handlers

BOOL CClipboardNotificationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Display the Clipboard data upon initialization
	DisplayClipboardData();
	
  // Tell Windows that this window is to receive notification
  // messages whenever the Clipboard is changed.
  SetClipboardViewer();

  OnBnClickedCheck1();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClipboardNotificationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClipboardNotificationDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClipboardNotificationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CClipboardNotificationDlg::DisplayClipboardData()
{
 // Initialize the clipboard data controls.
 m_strClipboardText = "";
 
 // Test to see if we can open the clipboard first.
 if (OpenClipboard()) 
 {
  // Application will only display ANSI text data.
  if (::IsClipboardFormatAvailable(CF_TEXT)
  || ::IsClipboardFormatAvailable(CF_OEMTEXT))
  {
    // Since the data is ANSI text, hide the "not 
    // ANSI text" message.
    m_stcNotText.ShowWindow(SW_HIDE);

    // Retrieve the Clipboard data (specifying that 
    // we want ANSI text (via the CF_TEXT value).
    HANDLE hClipboardData = GetClipboardData(CF_TEXT);

    // Call GlobalLock so that to retrieve a pointer
    // to the data associated with the handle returned
    // from GetClipboardData.
    char *pchData = (char*)GlobalLock(hClipboardData);

    // Set a local CString variable to the data
    // and then update the dialog with the Clipboard data
    m_strClipboardText = pchData;

    // Unlock the global memory.
    GlobalUnlock(hClipboardData);
  }
  else
  { 
    // Need to let the user know that the app is working, 
    // but that there is no ANSI text on the Clipboard
    // to display.
    m_stcNotText.ShowWindow(SW_SHOW);
  }

  // Finally, when finished I simply close the Clipboard
  // which has the effect of unlocking it so that other
  // applications can examine or modify its contents.
  CloseClipboard();

  // Update the dialog's controls with the new data.
  UpdateData(FALSE);
 }
}

LRESULT CClipboardNotificationDlg::OnClipboardChange(WPARAM w, LPARAM l) 
{
 // Get the current time
 CTime time = CTime::GetCurrentTime();

 // Format the time as we update the dialog's Last Updated value.
 m_strLastUpdated = time.Format("%a, %b %d, %Y -- %H:%M:%S");

 // Call the function to display the Clipboard data.
 DisplayClipboardData();

 return 0L;
}

void CClipboardNotificationDlg::OnBnClickedCheck1()
{
	UpdateData();

	if (m_bAlwaysOnTop == 1)
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | WS_EX_TOPMOST);
	}
	else
	{
		::SetWindowPos(GetSafeHwnd(), HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	}  
}

void CClipboardNotificationDlg::OnBnClickedButton1()
{
  CAboutDlg().DoModal();
}

void CAboutDlg::OnBnClickedOk()
{
	CWaitCursor wait;

  CString strUrl = "http://www.thecodechannel.com/redirect.asp?u=/&s=vcnb";
  if (32 >= (int)ShellExecute(NULL, "open", strUrl, NULL, NULL, SW_SHOWNORMAL))
	{
		AfxMessageBox("::ShellExecute failed to open this link!");
	}
}
